<script setup>
import { computed } from 'vue'
import { useToolStore } from '@/stores/useToolStore';

const props = defineProps(['connectorType'])
const ToolStore = useToolStore()
const currentConnector = ref(null)
const currentTool = ref(null)
const currentStep = ref('selectConnector')

await ToolStore.fetchConnectors(props.connectorType)
await ToolStore.fetchTools(props.connectorType)

const emits = defineEmits(['toolselected'])

function setcurrentStep(step) {
    currentStep.value = step
}

function selectConnector(connector) {
    currentConnector.value = connector
    currentStep.value = 'configureConnector'
}

async function selectTool(tool) {
    currentTool.value = tool
    emits('toolselected', tool)
}

async function createNewTool() {
    let tool = await ToolStore.createTool(currentConnector.value)
    selectTool(tool)
}

</script>


<template>
<v-row class="fill-height" v-if="currentStep == 'selectConnector'">
<v-col>
    <b>Choose a tool</b>
    <p class="text-overline mb-0" v-if="ToolStore.tools.size > 0">Tools already used</p>
    <v-row class="mt-0" v-if="ToolStore.tools.size > 0">
        <v-col cols="4" v-for="tool in ToolStore.tools.values()">
            <v-card
                :title="ToolStore.connectors.get(tool.connector).name"
                :subtitle="tool.name"
                :prepend-avatar="'data:image/png;base64, '+ToolStore.connectors.get(tool.connector).icon"
                @click="selectTool(tool)"
                color="#F5F5F5"
                class="pa-0">
                <template v-slot:prepend>
                    <v-avatar rounded="0"></v-avatar>
                </template>
            </v-card>
        </v-col>
    </v-row>
    <p class="text-overline mb-0 mt-4" v-if="ToolStore.tools.size > 0">Other tools</p>
    <v-row class="mt-0">
        <v-col cols="4" v-for="connector in ToolStore.connectors.values()">
            <v-card
                :title="connector.name"
                :prepend-avatar="'data:image/png;base64, '+connector.icon"
                @click="selectConnector(connector)"
                color="#F5F5F5"
                class="pa-0">
                <template v-slot:prepend>
                    <v-avatar rounded="0"></v-avatar>
                </template>
            </v-card>
        </v-col>
    </v-row>
</v-col>
<v-divider
    class="mx-4"
    vertical
></v-divider>
<v-col cols="3">
</v-col>
</v-row>

<v-row class="fill-height" v-if="currentStep == 'configureConnector'">
    <v-col class="d-flex flex-column fill-height">
    <div>
        Complete the form below to connect to {{ currentConnector.name }}
    </div>
    <div v-for="field in currentConnector.fields" class="ma-0">
        <v-text-field v-if="field.type == 'text'" :label="field.name" :hint="field.helper" :name="field.id" v-model="field.value"></v-text-field>
        <v-text-field v-if="field.type == 'password'" type="password" :label="field.name" :hint="field.helper" :name="field.id" v-model="field.value"></v-text-field>
    </div>
    <div class="mt-auto d-flex flex-row">
        <v-btn
            size="small"
            color="primary"
            class="ml-auto"
            @click="setcurrentStep('selectConnector')"
        >Back</v-btn>
        <v-btn
            size="small"
            color="primary"
            class="ml-5"
            @click="createNewTool()"
        >Next</v-btn>
    </div>
</v-col>
<v-divider class="mx-4" vertical></v-divider>
<v-col cols="3">
    <v-avatar
        rounded="0"
        size="x-small"
        :image="'data:image/png;base64, '+currentConnector.icon"
        class="mr-1"
    ></v-avatar>{{ currentConnector.name }}

    <p class="mt-2">
        {{ currentConnector.description }}
    </p>
</v-col>
</v-row>
</template>
